Bug 432037 - Losetup INFO: possible circular locking dependency detected
Summary: Losetup INFO: possible circular locking dependency detected
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: 9
Hardware: x86_64
OS: Linux
low
low
Target Milestone: ---
Assignee: Kernel Maintainer List
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2008-02-08 15:03 UTC by Zdenek Kabelac
Modified: 2009-07-14 15:42 UTC (History)
0 users

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2009-07-14 15:42:01 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Linux Kernel 10504 None None None Never

Description Zdenek Kabelac 2008-02-08 15:03:42 UTC
Description of problem:

While using losetup I've got this INFO message:
=======================================================
[ INFO: possible circular locking dependency detected ]
2.6.24-17.fc9 #1
-------------------------------------------------------
losetup/538 is trying to acquire lock:
 (&bdev->bd_mutex){--..}, at: [<ffffffff810d22ca>] __blkdev_put+0x24/0x14a

but task is already holding lock:
 (&lo->lo_ctl_mutex){--..}, at: [<ffffffff8850e200>] lo_ioctl+0x48/0xa0d [loop]

which lock already depends on the new lock.


the existing dependency chain (in reverse order) is:

-> #1 (&lo->lo_ctl_mutex){--..}:
       [<ffffffff8105801b>] __lock_acquire+0xbed/0xd8d
       [<ffffffff8850d305>] lo_open+0x2a/0x3d [loop]
       [<ffffffff81058215>] lock_acquire+0x5a/0x75
       [<ffffffff8850d305>] lo_open+0x2a/0x3d [loop]
       [<ffffffff8127e72c>] mutex_lock_nested+0xfc/0x295
       [<ffffffff8850d305>] lo_open+0x2a/0x3d [loop]
       [<ffffffff810d2717>] do_open+0xa9/0x2be
       [<ffffffff810d292c>] blkdev_open+0x0/0x59
       [<ffffffff810d292c>] blkdev_open+0x0/0x59
       [<ffffffff810d2959>] blkdev_open+0x2d/0x59
       [<ffffffff810ac2a1>] __dentry_open+0xeb/0x1c3
       [<ffffffff810ac430>] do_filp_open+0x2d/0x3d
       [<ffffffff8127fc1c>] _spin_unlock+0x17/0x20
       [<ffffffff810ac19e>] get_unused_fd_flags+0x116/0x127
       [<ffffffff810ac486>] do_sys_open+0x46/0xc3
       [<ffffffff8100c0f3>] tracesys+0xd5/0xda
       [<ffffffffffffffff>] 0xffffffffffffffff

-> #0 (&bdev->bd_mutex){--..}:
       [<ffffffff81057093>] print_circular_bug_header+0xcc/0xd3
       [<ffffffff81057f1f>] __lock_acquire+0xaf1/0xd8d
       [<ffffffff810d22ca>] __blkdev_put+0x24/0x14a
       [<ffffffff81058215>] lock_acquire+0x5a/0x75
       [<ffffffff810d22ca>] __blkdev_put+0x24/0x14a
       [<ffffffff8127e72c>] mutex_lock_nested+0xfc/0x295
       [<ffffffff810d22ca>] __blkdev_put+0x24/0x14a
       [<ffffffff810aea3c>] __fput+0xc2/0x18b
       [<ffffffff8850e821>] lo_ioctl+0x669/0xa0d [loop]
       [<ffffffff810553ea>] lock_release_holdtime+0x16/0xfe
       [<ffffffff810553ea>] lock_release_holdtime+0x16/0xfe
       [<ffffffff810be59b>] __d_lookup+0x16c/0x17e
       [<ffffffff810bf048>] dput+0x3c/0x10b
       [<ffffffff810b4cae>] do_lookup+0x63/0x1a2
       [<ffffffff810b711e>] __link_path_walk+0xc9e/0xdde
       [<ffffffff81056c8c>] mark_held_locks+0x57/0x72
       [<ffffffff8127e8a9>] mutex_lock_nested+0x279/0x295
       [<ffffffff81056e39>] trace_hardirqs_on+0x106/0x129
       [<ffffffff811251bd>] blkdev_driver_ioctl+0x5d/0x72
       [<ffffffff8112589f>] blkdev_ioctl+0x6cd/0x6f2
       [<ffffffff810d28a7>] do_open+0x239/0x2be
       [<ffffffff810d292c>] blkdev_open+0x0/0x59
       [<ffffffff810d292c>] blkdev_open+0x0/0x59
       [<ffffffff810ac4f7>] do_sys_open+0xb7/0xc3
       [<ffffffff810ac4f7>] do_sys_open+0xb7/0xc3
       [<ffffffff810d1c94>] block_ioctl+0x1b/0x1f
       [<ffffffff810b9571>] do_ioctl+0x21/0x6c
       [<ffffffff810b97f8>] vfs_ioctl+0x23c/0x252
       [<ffffffff810b985f>] sys_ioctl+0x51/0x72
       [<ffffffff8100c0f3>] tracesys+0xd5/0xda
       [<ffffffffffffffff>] 0xffffffffffffffff

other info that might help us debug this:

1 lock held by losetup/538:
 #0:  (&lo->lo_ctl_mutex){--..}, at: [<ffffffff8850e200>] lo_ioctl+0x48/0xa0d [loop]

stack backtrace:
Pid: 538, comm: losetup Not tainted 2.6.24-17.fc9 #1

Call Trace:
 [<ffffffff810571a0>] print_circular_bug_tail+0x69/0x72
 [<ffffffff81057093>] print_circular_bug_header+0xcc/0xd3
 [<ffffffff81057f1f>] __lock_acquire+0xaf1/0xd8d
 [<ffffffff810d22ca>] __blkdev_put+0x24/0x14a
 [<ffffffff81058215>] lock_acquire+0x5a/0x75
 [<ffffffff810d22ca>] __blkdev_put+0x24/0x14a
 [<ffffffff8127e72c>] mutex_lock_nested+0xfc/0x295
 [<ffffffff810d22ca>] __blkdev_put+0x24/0x14a
 [<ffffffff810aea3c>] __fput+0xc2/0x18b
 [<ffffffff8850e821>] :loop:lo_ioctl+0x669/0xa0d
 [<ffffffff810553ea>] lock_release_holdtime+0x16/0xfe
 [<ffffffff810553ea>] lock_release_holdtime+0x16/0xfe
 [<ffffffff810be59b>] __d_lookup+0x16c/0x17e
 [<ffffffff810bf048>] dput+0x3c/0x10b
 [<ffffffff810b4cae>] do_lookup+0x63/0x1a2
 [<ffffffff810b711e>] __link_path_walk+0xc9e/0xdde
 [<ffffffff81056c8c>] mark_held_locks+0x57/0x72
 [<ffffffff8127e8a9>] mutex_lock_nested+0x279/0x295
 [<ffffffff81056e39>] trace_hardirqs_on+0x106/0x129
 [<ffffffff811251bd>] blkdev_driver_ioctl+0x5d/0x72
 [<ffffffff8112589f>] blkdev_ioctl+0x6cd/0x6f2
 [<ffffffff810d28a7>] do_open+0x239/0x2be
 [<ffffffff810d292c>] blkdev_open+0x0/0x59
 [<ffffffff810d292c>] blkdev_open+0x0/0x59
 [<ffffffff810ac4f7>] do_sys_open+0xb7/0xc3
 [<ffffffff810ac4f7>] do_sys_open+0xb7/0xc3
 [<ffffffff810d1c94>] block_ioctl+0x1b/0x1f
 [<ffffffff810b9571>] do_ioctl+0x21/0x6c
 [<ffffffff810b97f8>] vfs_ioctl+0x23c/0x252
 [<ffffffff810b985f>] sys_ioctl+0x51/0x72
 [<ffffffff8100c0f3>] tracesys+0xd5/0xda



Version-Release number of selected component (if applicable):
2.6.24-17.fc9 

How reproducible:
Somewhere during the following steps (basically making accesible first partition
on a virtual raw qemu image)

Steps to Reproduce:
1. losetup /dev/loop0 disk.raw
2. losetup -o 32256  /dev/loop1 /dev/loop0
3. losetup -d /dev/loop1
4. losetup -d /dev/loop0 
  
Actual results:


Expected results:


Additional info:

Comment 1 Zdenek Kabelac 2008-04-25 09:11:53 UTC
This bug is tracked with this kernel bugzilla:

http://bugzilla.kernel.org/show_bug.cgi?id=10504


Comment 2 Bug Zapper 2008-05-14 05:05:18 UTC
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 3 Bug Zapper 2009-06-09 23:31:19 UTC
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 4 Bug Zapper 2009-07-14 15:42:01 UTC
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.